Subject: Re: [net-next v2 1/1] virtual-bus: Implementation of Virtual Bus

From: Jason Wang <[email-masked]>
Date: Tue, 19 Nov 2019 22:24:51 -0500 (EST)

----- Original Message -----
> On Tue, Nov 19, 2019 at 03:37:03PM +0800, Jason Wang wrote:
> 
> > > Jiri, Jason, me think that even virtio accelerated devices will need
> > > eswitch support. And hence, life cycling virtio accelerated devices via
> > > devlink makes a lot of sense to us.
> > > This way user has single tool to choose what type of device he want to
> > > use (similar to ip link add link type).
> > > So sub function flavour will be something like (virtio or sf).
> > 
> > Networking is only one of the types that is supported in virtio-mdev. The
> > codes are generic enough to support any kind of virtio device (block, scsi,
> > crypto etc). Sysfs is less flexible but type independent. I agree that
> > devlink is standard and feature richer but still network specific. It's
> > probably hard to add devlink to other type of physical drivers. I'm
> > thinking
> > whether it's possible to combine syfs and devlink: e.g the mdev is
> > available
> > only after the sub fuction is created and fully configured by devlink.
> 
> The driver providing the virtio should really be in control of the
> life cycle policy. For net related virtio that is clearly devlink.

As replied in another thread, there were already existed devices
(Intel IFC VF) that doesn't use devlink.

> 
> Even for block we may find that network storage providers (ie some
> HW accelerated virtio-blk-over-ethernet) will want to use devlink to
> create a combination ethernet and accelerated virtio-block widget.
> 
>

Note, there's already commercial virtio-blk done at PF level provided
by Ali ECS instance. So it's looks pretty clear to me it's almost
impossible to have every vendors to use devlink. Tie virtio soluton to
devlink seems a burden and actually devlink doesn't conflict with the
simple sysfs interface.

Thanks